import java.io.*;
import java.util.*;

//*** Change DWGraph to (Your Initials)Graph ***//

public class DWGraph extends M865Graph {

	protected Integer nC;				// the number of components
	protected Boolean cyclic;			// does this graph have cycles
	protected TreeMap degreeList;		// the degree of each node

	public DWGraph(SortedSet vertexSet, SortedSet edgeList) {
		super(vertexSet, edgeList);
		nC = null;
		cyclic = null;
		degreeList = null;
	}


	protected int countComponents() {
	
	/*** Insert your code for counting the components ***/
	
		return 0;
	}
	
					
	public int getNumberOfComponents() {
		if (nC == null) {
			return countComponents();
		} else {
			return nC.intValue();
		}
	}	

	public boolean hasCycles() {
		if (cyclic == null) {
			countComponents();
		} 
		return cyclic.booleanValue();
	}

	
	protected void computeDegrees() {

	/*** Insert your code for computing the degree of each vertex
	      and storing the vertex and its degree in degreeList     ***/
	
	}
	
	public int degreeOf(M865Vertex v) {
		if (degreeList == null) {
			computeDegrees();
		}
		return ((Integer)degreeList.get(v)).intValue();
	}

	public static void main (String args[])
		throws IOException {

		M865GraphReader graphReader;
		if (0 < args.length) {
			graphReader = new M865GraphReader(args[0]);
		} else {
			graphReader = new M865GraphReader();
		}
		graphReader.readEdgeList();
		/*** Uncomment the following statements to test your contributions
		M865Graph g = graphReader.getGraph();
		System.out.println(g);
		System.out.println("nC: " + g.getNumberOfComponents());
		System.out.println("Connected: " + g.isConnected());
		System.out.println("Has cycles: " + g.hasCycles());
		SortedSet v = g.getVertexSet();
		Iterator iter = v.iterator();
		while (iter.hasNext()) {
			M865Vertex vertex = (M865Vertex)iter.next();
			System.out.println("Degree of "+vertex+" is "+g.degreeOf(vertex));
		}
		***/
	}
}
