package ShapePack;

import java.awt.*;


/** The concrete Rectangle class. */

public class myRectangle extends Shape{
	
	public myRectangle(int x, int y, int w, int h, Color c) {
		super(x, y, w, h, c);
	}
	
	public myRectangle(int x, int y) {
		super(x, y, defaultWidth, defaultHeight, defaultColor);
	}
	
	public void draw(Graphics g) {
		g.setColor(this.color);
		g.fillRect(this.x, this.y, this.wide, this.high);  
	}

	public float area() {
		return( wide*high );
	}
	
	public float perimeter() {
		return( 2*(wide + high) );
	}

	public String toString() {
		return( "Rectangle:  " + super.toString() );
	}
}

