import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;

public class Checker02 extends Applet implements Runnable {

	private static final long serialVersionUID = 1L;
	
	Thread runner;
	int xpos,ux1,ux2;
	
	public void start()	 {
		if (runner == null) {
			runner = new Thread(this);
			runner.start();
		}
	}
	
	public void stop()	{
		if (runner != null) {
			runner = null;
		}
	}

	public void run() {
		setBackground(Color.blue);
		while (true) {
			for (xpos=5; xpos<=105; xpos+=4) {
				ux1 = xpos - 5;
				ux2 = xpos + 95;
				repaint();
				try { Thread.sleep(100); }
				catch (InterruptedException e) { }
			}
			for (xpos=105; xpos>=5; xpos-=4) {
				ux1 = xpos - 5;
				ux2 = xpos + 95;
				repaint();
				try { Thread.sleep(100); }
				catch (InterruptedException e) { }
			}
		}
	}
	
	public void update(Graphics g) {
		g.clipRect(ux1, 4, (ux2-ux1), 92);
		paint(g);
	}
	
	public void paint(Graphics g) {
		// Draw background
		g.setColor(Color.white);
		g.fillRect(101,0,100,100);
		g.setColor(Color.black);
		g.fillRect(0,0,100,100);
		
		// Draw checker
		g.setColor(Color.red);
		g.fillOval(xpos,5,90,90);
		
		// Reset the drawing area.
		ux1 = ux2 = 0;
	}
}