import java.util.*;

abstract public class M865Stack implements Cloneable, Collection {
	
	abstract public void push(Object o);
	//  pushes an object onto the stack.
	
	abstract public Object pop();
	//  removes and returns the object on the top of the stack.
	//  returns null if the stack is empty.
	
	abstract public Object peek();
	//  returns the object on the top of the stack.
	
	public boolean remove(Object o) throws UnsupportedOperationException {
	// Removes a single instance of the specified element from this collection,
	// if it is present (optional operation). 
		throw( new UnsupportedOperationException("remove is not implemented for the general M865Stack"));
	}
	 	 
	public boolean removeAll(Collection c) {
	// Removes all this collection's elements that are also contained in the
	// specified collection (optional operation). 
		throw( new UnsupportedOperationException("removeAll is not implemented for the general M865Stack"));
	}
	 
	public boolean retainAll(Collection c) {
	// Retains only the elements in this collection that are contained in the
	// specified collection (optional operation).		
		throw( new UnsupportedOperationException("retainAll is not implemented for the general M865Stack"));
	}
}
