import ShapePack.Shape;
import java.awt.*;


/** The concrete Ellipse class. */

public class myEllipse extends Shape{
	
	public myEllipse(int x, int y, int w, int h, Color c) {
		super(x, y, w, h, c);
	}
	
	public myEllipse(int x, int y) {
		this(x, y, defaultWidth, defaultHeight, defaultColor);
	}
	
	public void draw(Graphics g) {
		g.setColor(this.color);
		g.fillOval(this.x, this.y, this.wide, this.high);  
	}

	public float area() {
		return( (float)(Math.PI*0.25*wide*high) );
	}
	
	public float perimeter() {
		// Approximate perimeter
		// exact perimeter is 2*wide*Elliptic(sqrt(wide^2 - high^2)/wide)
		return( (float)(Math.PI*Math.sqrt(0.5*(wide*wide + high*high))) );
	}

	public String toString() {
		return( "Ellipse:  " + super.toString() );
	}
}
