/*        
    This program reads a file and prints out each
    numeric litteral.
    
    Daniel D. Warner   10/12/98
*/

import java.io.*;

public class TestTokenizer {

    public static void main(String args[]) {
        InputStreamReader stdin = new InputStreamReader(System.in);
        StreamTokenizer reader = new StreamTokenizer(stdin);
        reader.eolIsSignificant(true);
        int token = 0;
        while (token != StreamTokenizer.TT_EOF) {
            try {
                token = reader.nextToken();
                System.out.print( Integer.toString(token));
                switch ( token ) {
                    case StreamTokenizer.TT_EOF: {
                        System.out.println(": EOF");
                        break;
                    }
                    case StreamTokenizer.TT_WORD: {
                        System.out.println(": " + reader.sval);
                        break;
                    }
                    case StreamTokenizer.TT_NUMBER: {
                        //System.out.println(": " + Double.toString(reader.nval));
                        System.out.println(": " + reader.sval);
                        break;
                    }
                    case StreamTokenizer.TT_EOL: {
                        System.out.println(": EOL");
                        break;
                    }
                    default: {
                        System.out.println(": " + (char)token);
                    }
                }
            } catch (IOException e) {} 
        }
    }

}
